#include<stdio.h>   
#include<stddef.h>
#include<stdlib.h>
#include<math.h>
#include<time.h>
#include"ran2.h"
#define L 1000                   //population size
#define T_MAX 200                //duration of the simulation
#define IN_INFO 0.0              //institutional information
#define Pr_R 0.5                 //share of agents with risk sensitivity larger than 0.5
#define Pr_T 0.5                 //share of agents with trust towards the Institution larger than 0.5
#define S 2000                   //number of independent realizations

int main ()
{

  FILE *fa,*fb,*fd,*fe,*ff,*fg,*fh;
  int i,j,k,s,N,opj0,est_m;
  unsigned long int t,tt;
  double extr,extr2,extr3,Pij,Pji,om_aux,estraz,ita,nihil;
  int *erre,*av_info;
  double *beta,*tr_isti,*tr_peer,*av_tr_isti,*av_tr_peer,*av_erre,*av_beta,*dev,*om,*op,*audio;
  time_t Time;  
  long a2,*a;

  a2=-(unsigned)time(&Time);/
  a=&a2;

  nihil=0.0;

  N=L+1; //index 0 is for the Institution, indices from 1 to N are for the agents

  om=(double*)calloc(T_MAX+1,sizeof(double));//average opinion at time t 
  op=(double*)calloc(N,sizeof(double));//agents' opinion (op[0]=I)
  beta=(double*)calloc(N,sizeof(double));//proactiveness (tendency to communicate)
  erre=(int*)calloc(N,sizeof(int));//risk sensitivity
  audio=(double*)calloc(N,sizeof(double));//probability to listen to a medium (which communicates institutional evaluation I)
  tr_isti=(double*)calloc(N,sizeof(double));//trust towards the Institution
  tr_peer=(double*)calloc(N,sizeof(double));//trust towards peers
  av_beta=(double*)calloc(T_MAX+1,sizeof(double));//average proactiveness
  av_erre=(double*)calloc(T_MAX+1,sizeof(double));//average risk sensitiveness
  av_tr_isti=(double*)calloc(T_MAX+1,sizeof(double));//average trust towards the Institution
  av_tr_peer=(double*)calloc(T_MAX+1,sizeof(double));//average trust towards peers
  dev=(double*)calloc(T_MAX+1,sizeof(double));//average deviation of opionions from 0.5
  av_info=(int*)calloc(T_MAX+1,sizeof(int));//average fraction of agents sharing their opinion to peers

    //INITIALIZATIONS
  for (i=0;i<=T_MAX;i++){
    om[i]=0.0;
    dev[i]=0.0;
    av_beta[i]=0.0;
    av_erre[i]=0.0;
    av_info[i]=0;
    av_tr_isti[i]=0.0;
    av_tr_peer[i]=0.0;
  }

  if (S>=20){
    if ((fb=fopen("finConfig_R0.50T0.50_info0.00.dat","w"))==NULL){
      printf ("Impossibile aprire il file-b \n");
      exit (1);
    }
  }

  for (s=0;s<S;s++){  //SIMULATION'S START

    //INITIALIZATIONS
    for (i=0;i<N;i++){
      op[i]=1.0*ran2(a);
      beta[i]=1.0*ran2(a);
      audio[i]=1.0*ran2(a);//if audio[i]=1 foreach i --> every agent is reachedby institutional communication (through media)

      extr2=1.0*ran2(a);
	if (extr2<1.0/3.0)
	erre[i]=1;
      else {
	extr3=1.0*ran2(a);
	if (extr3<Pr_R)
	  erre[i]=2;
	else
	  erre[i]=0;
      }
      extr2=1.0*ran2(a);
      if (extr2<Pr_T)
	tr_isti[i]=0.5*ran2(a)+0.5;
      else
	tr_isti[i]=0.5*ran2(a);//*/

      tr_peer[i]=1.0-tr_isti[i];
    }
    op[0]=1.0*IN_INFO;

    //HERE WRITING MEASURABLES AT t=0
    om_aux=0;
    for (k=1;k<N;k++){
      av_beta[0]=av_beta[0]+beta[k];
      av_erre[0]=av_erre[0]+1.0*erre[k];
      av_tr_isti[0]=av_tr_isti[0]+tr_isti[k];
      av_tr_peer[0]=av_tr_peer[0]+tr_peer[k];
      om[0]=om[0]+op[k];
      if (op[k]>=0.5)
	om_aux++;
    }
    if (1.0*om_aux/(1.0*N)>=0.5)
      dev[0]=dev[0]+1.0*om_aux/(1.0*N)-0.5;
    else
      dev[0]=dev[0]+0.5-1.0*om_aux/(1.0*N);
    //END OF WRITING MEASURABLES AT t=0

    int aux=0;
    for (t=0;t<T_MAX;t++){           //dynamics starts here

      //INSTITUTIONAL COMMUNICATION
      for (k=1;k<N;k++){

	estraz=1.0*ran2(a);
	if (estraz<audio[k]){

	  est_m=3*ran2(a);
	  switch (est_m) {//media effect
	  case 0:
	    ita=0.5*(1.0-op[0])*ran2(a);
	    break;
	  case 1:
	    ita=0.0;
	    break;
	  case 2:
	    ita=(nihil-0.5*op[0])*ran2(a);
	    break;
	  default:
	    printf("\nERRORE NEL PRIMO CICLO SWITCH\nControllare EST_M E ITA!\n");
	    exit(0);
	  }

	  op[k]=op[k]+1.0*tr_isti[k]*((op[0]+ita)-op[k]);

	  switch (erre[k]) {
	  case 0:
	    op[k]=op[k]/2.0;
	    break;
	  case 1:
	    op[k]=1.0*op[k];
	    break;
	  case 2:
	    op[k]=(1.0+op[k])/2.0;
	    break;
	  default:
	    printf("\nERRORE NEL secondo CICLO SWITCH\nerre[%d]=%d\ts=%d\nControllare la definizione di erre!\n",j,erre[j],s+1);
	    exit(0);
	  }
	}

      }//END OF INSTITUTIONAL COMMUNICATION

      //COMMUNICATION AMONG PEERS
      for (tt=0;tt<L;tt++){
	i=L*ran2(a)+1; //speaker
      listener:
	j=L*ran2(a)+1; //listener
	if (j==i)
	  goto listener;
	opj0=op[j];

	Pij=pow(op[i],1.0/beta[i]);
	extr=1.0*ran2(a);
	if (extr<Pij){ //i SPEAKS
	  av_info[t+1]++;

	  op[j]=op[j]+1.0*tr_peer[j]*(op[i]-op[j]);

	  //HERE OPINION PROCESSING
	  if (erre[i]==2){               //alarmist speaker
	    if (erre[j]==2 && op[i]>=0.5)
	      op[j]=(1.0+op[j])/2.0;     //both alarmist, "pessimistic" speaker --> listener increases alarmism
	    if (op[i]<0.5)
	      op[j]=op[j]/2.0;           //alarmist and "optimistic" speaker --> listener decreases alarmism
	  }
	  else {                         //non-alarmist speaker
	    if (op[i]>0.5)
	      op[j]=(1.0+op[j])/2.0;     //non-alarmist but "pessimistic" speaker --> listener increases alarmism
	  }
	  
	} //END "i SPEAKS" CASE

	Pji=pow(opj0,1.0/beta[j]);
	extr=1.0*ran2(a);
	if (extr<Pji){ //j SPEAKS
	  av_info[t+1]++;

	  op[i]=op[i]+1.0*tr_peer[i]*(opj0-op[i]);

	  //HERE OPINION PROCESSING
	  if (erre[j]==2){               //alarmist speaker
	    if (erre[i]==2 && opj0>=0.5)
	      op[i]=(1.0+op[i])/2.0;     //both alarmist, "pessimistic" speaker --> listener increases alarmism
	    if (opj0<0.5)
	      op[i]=op[i]/2.0;           //alarmist and "optimistic" speaker --> listener decreases alarmism
	  }
	  else {                         //non-alarmist speaker
	    if (opj0>0.5)
	      op[i]=(1.0+op[i])/2.0;     //non-alarmist but "pessimistic" speaker --> listener increases alarmism
	  }

	} //END "j SPEAKS" CASE

      }//end internal cycle on tt. END COMMUNICATION AMONG PEERS

      //COMPUTING MEASURABLES
      om_aux=0;
      for (k=1;k<N;k++){
	av_beta[t+1]=av_beta[t+1]+beta[k];
	av_erre[t+1]=av_erre[t+1]+1.0*erre[k];
	av_tr_isti[t+1]=av_tr_isti[t+1]+tr_isti[k];
	om[t+1]=om[t+1]+op[k];
	if (op[k]>=0.5)
	  om_aux++;
      }
      if (1.0*om_aux/(1.0*N)>=0.5)
	dev[t+1]=dev[t+1]+1.0*om_aux/(1.0*N)-0.5;
      else
	dev[t+1]=dev[t+1]+0.5-1.0*om_aux/(1.0*N);

    }
    //END SINGLE REALIZATION (cycle over t)

    //HERE WRITING OUTPUT FILES
    if ((fa=fopen("opnm_R0.50T0.50_info0.00.dat","w"))==NULL){
      printf ("Impossibile aprire il file-a \n");
      exit (1);
    }
    if ((fd=fopen("avBETA_R0.50T0.50_info0.00.dat","w"))==NULL){
      printf ("Impossibile aprire il file-d \n");
      exit (1);
    }
    if ((fe=fopen("avERRE_R0.50T0.50_info0.00.dat","w"))==NULL){
      printf ("Impossibile aprire il file-e \n");
      exit (1);
    }
    if ((ff=fopen("avTR_ISTI_R0.50T0.50_info0.00.dat","w"))==NULL){
      printf ("Impossibile aprire il file-f \n");
      exit (1);
    }
    if ((fg=fopen("varo_R0.50T0.50_info0.00.dat","w"))==NULL){
      printf ("Impossibile aprire il file-g \n");
      exit (1);
    }
    if ((fh=fopen("avINF_R0.50T0.50_info0.00.dat","w"))==NULL){
      printf ("Impossibile aprire il file-h \n");
      exit (1);
    }

    fprintf(fa,"#realizzazioni=%d\n\n",s+1);
    for (tt=0;tt<=T_MAX;tt++)
      fprintf(fa,"%lu\t%g\n",tt,1.0*(double)om[tt]/((1.0+s)*L));

    fprintf(fd,"#realizzazioni=%d\n\n",s+1);
    for (tt=0;tt<=T_MAX;tt++)
      fprintf(fd,"%lu\t%g\n",tt,1.0*av_beta[tt]/((1.0+s)*L));

    fprintf(fe,"#realizzazioni=%d\n\n",s+1);
    for (tt=0;tt<=T_MAX;tt++)
      fprintf(fe,"%lu\t%g\n",tt,(1.0*av_erre[tt]/((1.0+s)*L))-1.0);

    fprintf(ff,"#realizzazioni=%d\n\n",s+1);
    for (tt=0;tt<=T_MAX;tt++)
      fprintf(ff,"%lu\t%g\n",tt,1.0*av_tr_isti[tt]/((1.0+s)*L));

    fprintf(fg,"#realizzazioni=%d\n\n",s+1);
    for (tt=0;tt<=T_MAX;tt++)
      fprintf(fg,"%lu\t%g\n",tt,0.5+1.0*dev[tt]/(1.0+s));

    fprintf(fh,"#realizzazioni=%d\n\n",s+1);
    for (tt=1;tt<=T_MAX;tt++)
      fprintf(fh,"%lu\t%g\n",tt,1.0*(double)av_info[tt]/((1.0+s)*L));

    if (S>=20 && s<20){
      fprintf(fb,"\n#s=%d\n",s+1);
      for (k=1;k<N;k++)
	fprintf(fb,"%d\t%g\n",k,op[k]);
    }

    fclose(fa);
    fclose(fd);
    fclose(fe);
    fclose(ff);
    fclose(fg);
    fclose(fh);
    if (S>=20 && s==19)
      fclose(fb);

  }

}
